System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Machine.PowerStatus.powerLineStatusChanged = Render;
window.onload = Init;
var timer;

function Init(){
	scanSkinDir();
	selectedSkin = parseInt(get("selectedSkin"))||(Math.floor(Math.random()*100)%skin.length);
	size = get("size")||2; 
	showRemainingTime = get("showRemainingTime")||1;
	timeText = powerImage.addTextObject('', 'Tahoma', 0, "Black", 0,0);
	Render();
}

function SettingsClosed(){
	debugLog("SettingsClosed()");
	Render();
}

function prettyTime(m){
	if(m<0) return '';
	debugLog('prettyTime(' + m + ')');
	h = Math.floor(m/60);
	m = Math.floor(m%60);
	prettyTimeText = (h>0?h+':':'') + (m<10&&h>0?'0'+m:m);
	debugLog('prettyTime = ' + prettyTimeText);
	return prettyTimeText;
}

function doubleClick(){
	selectedSkin=(selectedSkin+1)%skin.length;
	Render();
}

function setTimeText(str){
	debugLog("setting time text: " + str);
	timeText.value = str;
	timeText.top = 3;
	timeText.left = Math.ceil(264/size);
	timeText.fontSize = Math.ceil(13-size);
	timeText.color = 'white';
	timeText.align = 2;
	timeText.addGlow("black", 2, 75);
}

function scanSkinDir()
{   
	debugLog('Searching for skins...');
	skin = Array();
    try
    {
        var cursorObject = System.Shell.itemFromPath(System.Gadget.path + "\\skins"); 
    }
    catch(e)
    {
        return null;
    }
    var cursor = cursorObject.SHFolder.Items;
    if(cursorObject.type != "Compressed (zipped) Folder")
    {
        for(var i=0;i<cursor.count;i++)
        {
            if(cursor.item(i).isFolder)
            {
            	debugLog('found ' + cursor.item(i).name);
               skin.push(cursor.item(i).name);
            }
        }
    }
    curFolderObject = null;
    return null;
}


function setPowerImage(){
	var percent = System.Machine.PowerStatus.batteryPercentRemaining;
	var level = Math.floor(percent*16/100)+1;
	if(level < 1 || level > 17) //something's wrong with the gauge, trying to show the N/A icon
		level = 17;
	var prettytime = percent!=255 ? prettyTime(System.Machine.PowerStatus.batteryCapacityTotal/60) : '';
	setTimeText(showRemainingTime ? prettytime : '');

	powerImage.src = 
		'skins/'+ 
		skin[selectedSkin] + '/' + 
		'BatteryBG_' + //iPhone prefix
		level +
		'.png';

	powerImage.title = skin[selectedSkin] + '\n' + (percent>100?'N/A':(percent + '%')) + (prettytime==''?'':(' (' + prettytime + ')'));

	debugLog("path to image: " + powerImage.src);
}
function Render()
{
	document.body.style.width = powerImage.style.width = Math.ceil(264/size);
	document.body.style.height = powerImage.style.height = Math.ceil(129/size);
	setPowerImage();
	if(timer != null) clearTimeout(timer);
	timer = setTimeout(Render,1000); //checking back here again in one second
}
function scanSkinDir()
{   
	debugLog('scanSkinDir started');
	skin = Array();
    debugLog('Searching for skins...');
    try
    {
        var cursorObject = System.Shell.itemFromPath(System.Gadget.path + "\\skins"); 
    }
    catch(e)
    {
        return null;
    }
    var cursor = cursorObject.SHFolder.Items;
    for(var i=0;i<cursor.count;i++)
    {
        if(cursor.item(i).isFolder)
        {
			try{
	        	processSkin(cursor.item(i).name);
			}
			catch(e){
				debugLog('processing skin "' + cursor.item(i).name + '" failed: ' + e);
			}
        }
    }

	debugLog('scanSkinDir finished');
}

function processSkin(skinName){
    debugLog('Processing skin: ' + skinName);
    try
    {
        var cursorObject = System.Shell.itemFromPath(System.Gadget.path + "\\skins\\" + skinName); 
    }
    catch(e)
    {
        return null;
    }
    var cursor = cursorObject.SHFolder.Items;
    var levelCount = 0;
	for(var i=0;i<cursor.count;i++)
	{
		var itemPath = cursor.item(i).path;
		debugLog('parsing file: ' + itemPath)
		
		if(!cursor.item(i).isFolder && itemPath.substr(itemPath.lastIndexOf(".")) == ".png")
		{
			var value = itemPath.substr(itemPath.lastIndexOf("\\")).toLowerCase().replace('\\batterybg_','').replace('.png','');
			if(value >= 1 && value <= 17) levelCount++;
		}
	}

	if(levelCount != 17) //invalid skin check
    {
    	debugLog('missing some basic battery levels in the skin dir');
		return;
    }
    
    skin.push(skinName);
}